The Spring Framework

## org.springframework.orm.hibernate3
Class FilterDefinitionFactoryBean

    java.lang.Object
      org.springframework.orm.hibernate3.FilterDefinitionFactoryBean

All Implemented Interfaces:
  BeanNameAware, FactoryBean, InitializingBean

    public class FilterDefinitionFactoryBean

extends Object
implements FactoryBean, BeanNameAware, InitializingBean

Convenient FactoryBean for defining Hibernate FilterDefinitions. Exposes a corresponding Hibernate FilterDefinition object.

Typically defined as an inner bean within a LocalSessionFactoryBean definition, as the list element for the "filterDefinitions" bean property. For example:

     <bean id="sessionFactory" class="org.springframework.orm.hibernate3.LocalSessionFactoryBean">
       ...
       <property name="filterDefinitions">
         <list>
           <bean class="org.springframework.orm.hibernate3.FilterDefinitionFactoryBean">
             <property name="filterName" value="myFilter"/>
             <property name="parameterTypes">
               <props>
                 <prop key="myParam">string</prop>
                 <prop key="myOtherParam">long</prop>
               </props>
             </property>
           </bean>
         </list>
       </property>
       ...
     </bean>

Alternatively, specify a bean id (or name) attribute for the inner bean, instead of the "filterName" property.

Since:
  1.2
Author:
  Juergen Hoeller
See Also:
  `FilterDefinition`, `LocalSessionFactoryBean.setFilterDefinitions(org.hibernate.engine.FilterDefinition[])`

Constructor Summary
`FilterDefinitionFactoryBean()`

Method Summary
`void` `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`Object` `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class` `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` `isSingleton()` Is the object managed by this factory a singleton?
`void` `setBeanName(String name)` If no explicit filter name has been specified, the bean name of the FilterDefinitionFactoryBean will be used.
`void` `setDefaultFilterCondition(String defaultFilterCondition)` Specify a default filter condition for the filter, if any.
`void` `setFilterName(String filterName)` Set the name of the filter.
`void` `setParameterTypes(Properties parameterTypes)` Set the parameter types for the filter, with parameter names as keys and type names as values.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FilterDefinitionFactoryBean

    public FilterDefinitionFactoryBean()

Method Detail

### setFilterName

    public void setFilterName(String filterName)

  Set the name of the filter.

### setParameterTypes

    public void setParameterTypes(Properties parameterTypes)

  Set the parameter types for the filter, with parameter names as keys and type names as values.

  See Also:
    `TypeFactory.heuristicType(String)`

### setDefaultFilterCondition

    public void setDefaultFilterCondition(String defaultFilterCondition)

  Specify a default filter condition for the filter, if any.

### setBeanName

    public void setBeanName(String name)

  If no explicit filter name has been specified, the bean name of the FilterDefinitionFactoryBean will be used.

  Specified by:
    `setBeanName` in interface `BeanNameAware`
  Parameters:
    `name` - the name of the bean in the factory. Note that this name is the actual bean name used in the factory, which may differ from the originally specified name: in particular for inner bean names, the actual bean name might have been made unique through appending "#..." suffixes. Use the `BeanFactoryUtils.originalBeanName(String)` method to extract the original bean name (without suffix), if desired.
  See Also:
    `setFilterName(java.lang.String)`

### afterPropertiesSet

    public void afterPropertiesSet()

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`

### getObject

    public Object getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public Class getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

The Spring Framework

Copyright © 2002-2008 The Spring Framework.